diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 95a6f1a..be58cbd 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,14 +1,12 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::mangled::ToMangled;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::symbol::Symbol;
-use crate::syntax::typename::ToTypename;
 use crate::syntax::{
     self, check, mangle, Api, ExternFn, ExternType, Signature, Struct, Type, Types,
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned, ToTokens};
-use syn::{parse_quote, spanned::Spanned, Error, ItemMod, Result, Token};
+use syn::{parse_quote, Error, ItemMod, Result, Token};
 
 pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
     let ident = &ffi.ident;
@@ -23,38 +21,6 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
     let mut expanded = TokenStream::new();
     let mut hidden = TokenStream::new();
 
-    // "Header" to define newtypes locally so we can implement
-    // traits on them.
-    expanded.extend(quote! {
-        pub struct Vector<T>(pub ::cxx::RealVector<T>);
-        impl<T: cxx::private::VectorTarget<T>> Vector<T> {
-            pub fn size(&self) -> usize {
-                self.0.size()
-            }
-            pub fn get(&self, pos: usize) -> Option<&T> {
-                self.0.get(pos)
-            }
-            pub fn get_unchecked(&self, pos: usize) -> &T {
-                self.0.get_unchecked(pos)
-            }
-            pub fn is_empty(&self) -> bool {
-                self.0.is_empty()
-            }
-            pub fn push_back(&mut self, item: &T) {
-                self.0.push_back(item)
-            }
-        }
-        impl<'a, T: cxx::private::VectorTarget<T>> IntoIterator for &'a Vector<T> {
-            type Item = &'a T;
-            type IntoIter = <&'a ::cxx::RealVector<T> as IntoIterator>::IntoIter;
-
-            fn into_iter(self) -> Self::IntoIter {
-                self.0.into_iter()
-            }
-        }
-        unsafe impl<T> Send for Vector<T> where T: Send + cxx::private::VectorTarget<T> {}
-    });
-
     for api in &apis {
         if let Api::RustType(ety) = api {
             expanded.extend(expand_rust_type(ety));
@@ -89,32 +55,23 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
             }
         } else if let Type::RustVec(ty) = ty {
             if let Type::Ident(ident) = &ty.inner {
-                hidden.extend(expand_rust_vec(namespace, &ty.inner, ident));
+                if Atom::from(ident).is_none() {
+                    hidden.extend(expand_rust_vec(namespace, ident));
+                }
             }
         } else if let Type::UniquePtr(ptr) = ty {
             if let Type::Ident(ident) = &ptr.inner {
                 if Atom::from(ident).is_none() {
-                    expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types));
-                }
-            } else if let Type::Vector(_) = &ptr.inner {
-                // Generate code for unique_ptr<vector<T>> if T is not an atom
-                // or if T is a primitive.
-                // Code for primitives is already generated
-                match Atom::from(ident) {
-                    None => expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types)),
-                    Some(atom) => {
-                        if atom.is_valid_vector_target() {
-                            expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types));
-                        }
-                    }
+                    expanded.extend(expand_unique_ptr(namespace, ident, types));
                 }
             }
-        } else if let Type::Vector(ptr) = ty {
+        } else if let Type::CxxVector(ptr) = ty {
             if let Type::Ident(ident) = &ptr.inner {
                 if Atom::from(ident).is_none() {
-                    // Generate code for Vector<T> if T is not an atom
-                    // Code for atoms is already generated
-                    expanded.extend(expand_vector(namespace, &ptr.inner));
+                    // Generate impl for CxxVector<T> if T is a struct or opaque
+                    // C++ type. Impl for primitives is already provided by cxx
+                    // crate.
+                    expanded.extend(expand_cxx_vector(namespace, ident));
                 }
             }
         }
@@ -189,6 +146,8 @@ fn expand_cxx_function_decl(namespace: &Namespace, efn: &ExternFn, types: &Types
         let ty = expand_extern_type(&arg.ty);
         if arg.ty == RustString {
             quote!(#ident: *const #ty)
+        } else if let Type::RustVec(_) = arg.ty {
+            quote!(#ident: *const #ty)
         } else if let Type::Fn(_) = arg.ty {
             quote!(#ident: ::cxx::private::FatFunction)
         } else if types.needs_indirect_abi(&arg.ty) {
@@ -250,12 +209,12 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::into_raw(#var)),
             Type::UniquePtr(_) => quote!(::cxx::UniquePtr::into_raw(#var)),
-            Type::RustVec(_) => quote!(::cxx::RustVec::from(#var)),
+            Type::RustVec(_) => quote!(#var.as_mut_ptr() as *const ::cxx::private::RustVec<_>),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
                     quote!(::cxx::private::RustString::from_ref(#var))
                 }
-                Type::RustVec(_) => quote!(::cxx::RustVec::from_ref(#var)),
+                Type::RustVec(_) => quote!(::cxx::private::RustVec::from_ref(#var)),
                 _ => quote!(#var),
             },
             Type::Str(_) => quote!(::cxx::private::RustStr::from(#var)),
@@ -324,11 +283,13 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
                 Some(quote!(#call.map(|r| r.into_string())))
             }
             Type::RustBox(_) => Some(quote!(#call.map(|r| ::std::boxed::Box::from_raw(r)))),
+            Type::RustVec(_) => Some(quote!(#call.map(|r| r.into_vec()))),
             Type::UniquePtr(_) => Some(quote!(#call.map(|r| ::cxx::UniquePtr::from_raw(r)))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
                     Some(quote!(#call.map(|r| r.as_string())))
                 }
+                Type::RustVec(_) => Some(quote!(#call.map(|r| r.as_vec()))),
                 _ => None,
             },
             Type::Str(_) => Some(quote!(#call.map(|r| r.as_str()))),
@@ -339,9 +300,11 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
         efn.ret.as_ref().and_then(|ret| match ret {
             Type::Ident(ident) if ident == RustString => Some(quote!(#call.into_string())),
             Type::RustBox(_) => Some(quote!(::std::boxed::Box::from_raw(#call))),
+            Type::RustVec(_) => Some(quote!(#call.into_vec())),
             Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::from_raw(#call))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => Some(quote!(#call.as_string())),
+                Type::RustVec(_) => Some(quote!(#call.as_vec())),
                 _ => None,
             },
             Type::Str(_) => Some(quote!(#call.as_str())),
@@ -464,9 +427,11 @@ fn expand_rust_function_shim_impl(
                 quote!(::std::mem::take((*#ident).as_mut_string()))
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::from_raw(#ident)),
+            Type::RustVec(_) => quote!(::std::mem::take((*#ident).as_mut_vec())),
             Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#ident)),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(i) if i == RustString => quote!(#ident.as_string()),
+                Type::RustVec(_) => quote!(#ident.as_vec()),
                 _ => quote!(#ident),
             },
             Type::Str(_) => quote!(#ident.as_str()),
@@ -497,11 +462,13 @@ fn expand_rust_function_shim_impl(
                 Some(quote!(::cxx::private::RustString::from(#call)))
             }
             Type::RustBox(_) => Some(quote!(::std::boxed::Box::into_raw(#call))),
+            Type::RustVec(_) => Some(quote!(::cxx::private::RustVec::from(#call))),
             Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::into_raw(#call))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
                     Some(quote!(::cxx::private::RustString::from_ref(#call)))
                 }
+                Type::RustVec(_) => Some(quote!(::cxx::private::RustVec::from_ref(#call))),
                 _ => None,
             },
             Type::Str(_) => Some(quote!(::cxx::private::RustStr::from(#call))),
@@ -578,42 +545,54 @@ fn expand_rust_box(namespace: &Namespace, ident: &Ident) -> TokenStream {
     }
 }
 
-fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStream {
-    let inner = ty;
-    let mangled = ty.to_mangled(&namespace.segments) + "$";
-    let link_prefix = format!("cxxbridge02$rust_vec${}", mangled);
+fn expand_rust_vec(namespace: &Namespace, elem: &Ident) -> TokenStream {
+    let link_prefix = format!("cxxbridge02$rust_vec${}{}$", namespace, elem);
+    let link_new = format!("{}new", link_prefix);
     let link_drop = format!("{}drop", link_prefix);
-    let link_vector_from = format!("{}vector_from", link_prefix);
     let link_len = format!("{}len", link_prefix);
+    let link_data = format!("{}data", link_prefix);
+    let link_stride = format!("{}stride", link_prefix);
 
-    let local_prefix = format_ident!("{}__vec_", ident);
+    let local_prefix = format_ident!("{}__vec_", elem);
+    let local_new = format_ident!("{}new", local_prefix);
     let local_drop = format_ident!("{}drop", local_prefix);
-    let local_vector_from = format_ident!("{}vector_from", local_prefix);
     let local_len = format_ident!("{}len", local_prefix);
+    let local_data = format_ident!("{}data", local_prefix);
+    let local_stride = format_ident!("{}stride", local_prefix);
 
-    let span = ty.span();
+    let span = elem.span();
     quote_spanned! {span=>
         #[doc(hidden)]
-        #[export_name = #link_drop]
-        unsafe extern "C" fn #local_drop(this: *mut ::cxx::RustVec<#inner>) {
-            std::ptr::drop_in_place(this);
+        #[export_name = #link_new]
+        unsafe extern "C" fn #local_new(this: *mut ::cxx::private::RustVec<#elem>) {
+            ::std::ptr::write(this, ::cxx::private::RustVec::new());
         }
-        #[export_name = #link_vector_from]
-        unsafe extern "C" fn #local_vector_from(this: *mut ::cxx::RustVec<#inner>, vector: *mut ::cxx::RealVector<#inner>) {
-            this.as_ref().unwrap().into_vector(vector.as_mut().unwrap());
+        #[doc(hidden)]
+        #[export_name = #link_drop]
+        unsafe extern "C" fn #local_drop(this: *mut ::cxx::private::RustVec<#elem>) {
+            ::std::ptr::drop_in_place(this);
         }
+        #[doc(hidden)]
         #[export_name = #link_len]
-        unsafe extern "C" fn #local_len(this: *const ::cxx::RustVec<#inner>) -> usize {
-            this.as_ref().unwrap().len()
+        unsafe extern "C" fn #local_len(this: *const ::cxx::private::RustVec<#elem>) -> usize {
+            (*this).len()
+        }
+        #[doc(hidden)]
+        #[export_name = #link_data]
+        unsafe extern "C" fn #local_data(this: *const ::cxx::private::RustVec<#elem>) -> *const #elem {
+            (*this).as_ptr()
+        }
+        #[doc(hidden)]
+        #[export_name = #link_stride]
+        unsafe extern "C" fn #local_stride() -> usize {
+            ::std::mem::size_of::<#elem>()
         }
     }
 }
 
-fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenStream {
-    let name = ty.to_typename(&namespace.segments);
-    let inner = ty;
-    let mangled = ty.to_mangled(&namespace.segments) + "$";
-    let prefix = format!("cxxbridge02$unique_ptr${}", mangled);
+fn expand_unique_ptr(namespace: &Namespace, ident: &Ident, types: &Types) -> TokenStream {
+    let name = ident.to_string();
+    let prefix = format!("cxxbridge02$unique_ptr${}{}$", namespace, ident);
     let link_null = format!("{}null", prefix);
     let link_new = format!("{}new", prefix);
     let link_raw = format!("{}raw", prefix);
@@ -621,8 +600,8 @@ fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenSt
     let link_release = format!("{}release", prefix);
     let link_drop = format!("{}drop", prefix);
 
-    let new_method = match ty {
-        Type::Ident(ident) if types.structs.contains_key(ident) => Some(quote! {
+    let new_method = if types.structs.contains_key(ident) {
+        Some(quote! {
             fn __new(mut value: Self) -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_new]
@@ -632,13 +611,14 @@ fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenSt
                 unsafe { __new(&mut repr, &mut value) }
                 repr
             }
-        }),
-        _ => None,
+        })
+    } else {
+        None
     };
 
     quote! {
-        unsafe impl ::cxx::private::UniquePtrTarget for #inner {
-            const __NAME: &'static str = #name;
+        unsafe impl ::cxx::private::UniquePtrTarget for #ident {
+            const __NAME: &'static dyn ::std::fmt::Display = &#name;
             fn __null() -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_null]
@@ -652,7 +632,7 @@ fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenSt
             unsafe fn __raw(raw: *mut Self) -> *mut ::std::ffi::c_void {
                 extern "C" {
                     #[link_name = #link_raw]
-                    fn __raw(this: *mut *mut ::std::ffi::c_void, raw: *mut #inner);
+                    fn __raw(this: *mut *mut ::std::ffi::c_void, raw: *mut #ident);
                 }
                 let mut repr = ::std::ptr::null_mut::<::std::ffi::c_void>();
                 __raw(&mut repr, raw);
@@ -661,14 +641,14 @@ fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenSt
             unsafe fn __get(repr: *mut ::std::ffi::c_void) -> *const Self {
                 extern "C" {
                     #[link_name = #link_get]
-                    fn __get(this: *const *mut ::std::ffi::c_void) -> *const #inner;
+                    fn __get(this: *const *mut ::std::ffi::c_void) -> *const #ident;
                 }
                 __get(&repr)
             }
             unsafe fn __release(mut repr: *mut ::std::ffi::c_void) -> *mut Self {
                 extern "C" {
                     #[link_name = #link_release]
-                    fn __release(this: *mut *mut ::std::ffi::c_void) -> *mut #inner;
+                    fn __release(this: *mut *mut ::std::ffi::c_void) -> *mut #ident;
                 }
                 __release(&mut repr)
             }
@@ -683,85 +663,81 @@ fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenSt
     }
 }
 
-fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
-    let inner = ty;
-    let mangled = ty.to_mangled(&namespace.segments) + "$";
-    let prefix = format!("cxxbridge02$std$vector${}", mangled);
-    let link_length = format!("{}length", prefix);
+fn expand_cxx_vector(namespace: &Namespace, elem: &Ident) -> TokenStream {
+    let name = elem.to_string();
+    let prefix = format!("cxxbridge02$std$vector${}{}$", namespace, elem);
+    let link_size = format!("{}size", prefix);
     let link_get_unchecked = format!("{}get_unchecked", prefix);
     let link_push_back = format!("{}push_back", prefix);
+    let unique_ptr_prefix = format!("cxxbridge02$unique_ptr$std$vector${}{}$", namespace, elem);
+    let link_unique_ptr_null = format!("{}null", unique_ptr_prefix);
+    let link_unique_ptr_raw = format!("{}raw", unique_ptr_prefix);
+    let link_unique_ptr_get = format!("{}get", unique_ptr_prefix);
+    let link_unique_ptr_release = format!("{}release", unique_ptr_prefix);
+    let link_unique_ptr_drop = format!("{}drop", unique_ptr_prefix);
 
     quote! {
-        impl ::cxx::private::VectorTarget<#inner> for #inner {
-            fn get_unchecked(v: &::cxx::RealVector<#inner>, pos: usize) -> &#inner {
+        unsafe impl ::cxx::private::VectorElement for #elem {
+            const __NAME: &'static dyn ::std::fmt::Display = &#name;
+            fn __vector_size(v: &::cxx::CxxVector<Self>) -> usize {
                 extern "C" {
-                    #[link_name = #link_get_unchecked]
-                    fn __get_unchecked(_: &::cxx::RealVector<#inner>, _: usize) -> &#inner;
+                    #[link_name = #link_size]
+                    fn __vector_size(_: &::cxx::CxxVector<#elem>) -> usize;
                 }
-                unsafe {
-                    __get_unchecked(v, pos)
+                unsafe { __vector_size(v) }
+            }
+            unsafe fn __get_unchecked(v: &::cxx::CxxVector<Self>, pos: usize) -> &Self {
+                extern "C" {
+                    #[link_name = #link_get_unchecked]
+                    fn __get_unchecked(_: &::cxx::CxxVector<#elem>, _: usize) -> *const #elem;
                 }
+                &*__get_unchecked(v, pos)
             }
-            fn vector_length(v: &::cxx::RealVector<#inner>) -> usize {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_length]
-                        fn __vector_length(_: &::cxx::RealVector<#inner>) -> usize;
-                    }
-                    __vector_length(v)
+            fn __push_back(v: &::cxx::CxxVector<Self>, item: &Self) {
+                extern "C" {
+                    #[link_name = #link_push_back]
+                    fn __push_back(_: &::cxx::CxxVector<#elem>, _: &#elem);
                 }
+                unsafe { __push_back(v, item) }
             }
-            fn push_back(v: &::cxx::RealVector<#inner>, item: &#inner) {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_push_back]
-                        fn __push_back(_: &::cxx::RealVector<#inner>, _: &#inner) -> usize;
-                    }
-                    __push_back(v, item);
+            fn __unique_ptr_null() -> *mut ::std::ffi::c_void {
+                extern "C" {
+                    #[link_name = #link_unique_ptr_null]
+                    fn __unique_ptr_null(this: *mut *mut ::std::ffi::c_void);
                 }
+                let mut repr = ::std::ptr::null_mut::<::std::ffi::c_void>();
+                unsafe { __unique_ptr_null(&mut repr) }
+                repr
             }
-        }
-    }
-}
-
-pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
-    let ty = Type::Ident(ident);
-    let inner = &ty;
-    let namespace = Namespace { segments: vec![] };
-    let mangled = ty.to_mangled(&namespace.segments) + "$";
-    let prefix = format!("cxxbridge02$std$vector${}", mangled);
-    let link_length = format!("{}length", prefix);
-    let link_get_unchecked = format!("{}get_unchecked", prefix);
-    let link_push_back = format!("{}push_back", prefix);
-
-    quote! {
-        impl VectorTarget<#inner> for #inner {
-            fn get_unchecked(v: &RealVector<#inner>, pos: usize) -> &#inner {
+            unsafe fn __unique_ptr_raw(raw: *mut ::cxx::CxxVector<Self>) -> *mut ::std::ffi::c_void {
                 extern "C" {
-                    #[link_name = #link_get_unchecked]
-                    fn __get_unchecked(_: &RealVector<#inner>, _: usize) -> &#inner;
+                    #[link_name = #link_unique_ptr_raw]
+                    fn __unique_ptr_raw(this: *mut *mut ::std::ffi::c_void, raw: *mut ::cxx::CxxVector<#elem>);
                 }
-                unsafe {
-                    __get_unchecked(v, pos)
+                let mut repr = ::std::ptr::null_mut::<::std::ffi::c_void>();
+                __unique_ptr_raw(&mut repr, raw);
+                repr
+            }
+            unsafe fn __unique_ptr_get(repr: *mut ::std::ffi::c_void) -> *const ::cxx::CxxVector<Self> {
+                extern "C" {
+                    #[link_name = #link_unique_ptr_get]
+                    fn __unique_ptr_get(this: *const *mut ::std::ffi::c_void) -> *const ::cxx::CxxVector<#elem>;
                 }
+                __unique_ptr_get(&repr)
             }
-            fn vector_length(v: &RealVector<#inner>) -> usize {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_length]
-                        fn __vector_length(_: &RealVector<#inner>) -> usize;
-                    }
-                    __vector_length(v)
+            unsafe fn __unique_ptr_release(mut repr: *mut ::std::ffi::c_void) -> *mut ::cxx::CxxVector<Self> {
+                extern "C" {
+                    #[link_name = #link_unique_ptr_release]
+                    fn __unique_ptr_release(this: *mut *mut ::std::ffi::c_void) -> *mut ::cxx::CxxVector<#elem>;
                 }
+                __unique_ptr_release(&mut repr)
             }
-            fn push_back(v: &RealVector<#inner>, item: &#inner) {
-                unsafe {
-                    extern "C" {
-                        #[link_name = #link_push_back]
-                        fn __push_back(_: &RealVector<#inner>, _: &#inner) -> usize;
-                    }
-                    __push_back(v, item);
+            unsafe fn __unique_ptr_drop(mut repr: *mut ::std::ffi::c_void) {
+                extern "C" {
+                    #[link_name = #link_unique_ptr_drop]
+                    fn __unique_ptr_drop(this: *mut *mut ::std::ffi::c_void);
                 }
+                __unique_ptr_drop(&mut repr);
             }
         }
     }
@@ -787,12 +763,15 @@ fn expand_extern_type(ty: &Type) -> TokenStream {
             let inner = expand_extern_type(&ty.inner);
             quote!(*mut #inner)
         }
-        Type::RustVec(ty) => quote!(::cxx::RustVec<#ty>),
+        Type::RustVec(ty) => {
+            let elem = expand_extern_type(&ty.inner);
+            quote!(::cxx::private::RustVec<#elem>)
+        }
         Type::Ref(ty) => match &ty.inner {
             Type::Ident(ident) if ident == RustString => quote!(&::cxx::private::RustString),
             Type::RustVec(ty) => {
                 let inner = expand_extern_type(&ty.inner);
-                quote!(&::cxx::RustVec<#inner>)
+                quote!(&::cxx::private::RustVec<#inner>)
             }
             _ => quote!(#ty),
         },
diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index 87fe405..b56f58e 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -14,7 +14,7 @@ mod syntax;
 
 use crate::syntax::namespace::Namespace;
 use proc_macro::TokenStream;
-use syn::{parse_macro_input, Ident, ItemMod};
+use syn::{parse_macro_input, ItemMod};
 
 /// `#[cxx::bridge] mod ffi { ... }`
 ///
@@ -44,9 +44,3 @@ pub fn bridge(args: TokenStream, input: TokenStream) -> TokenStream {
         .unwrap_or_else(|err| err.to_compile_error())
         .into()
 }
-
-#[proc_macro]
-pub fn vector_builtin(input: TokenStream) -> TokenStream {
-    let ident = parse_macro_input!(input as Ident);
-    expand::expand_vector_builtin(ident).into()
-}
diff --git a/src/concat.rs b/src/concat.rs
new file mode 100644
index 0000000..e67e50d
--- /dev/null
+++ b/src/concat.rs
@@ -0,0 +1,6 @@
+macro_rules! attr {
+    (#[$name:ident = $value:expr] $($rest:tt)*) => {
+        #[$name = $value]
+        $($rest)*
+    };
+}
